/**
 * Copyright (c) 2018, 2019, 2020, 2021 Adrian Siekierka
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
!function(){"use strict";let e,t=Date.now();function i(e,t,i){let r=32;for(;r>8&&(t.font="bold "+r+"px sans-serif",!(t.measureText(i).width<=e.width-4));)r--;t.fillStyle="rgba(0, 0, 0, 0.75)",t.fillRect(0,0,e.width,e.height),t.textBaseline="middle";const s=(e.width-t.measureText(i).width)/2,n=e.height/2;t.fillStyle="#000000",t.fillText(i,s+2,n+2),t.fillStyle="#ffffff",t.fillText(i,s,n)}function r(){return Date.now()-t}function s(){try{return window.indexedDB||window.webkitIndexedDB||window.mozIndexedDB}catch(e){return}}function n(e,t){return new Promise(((i,r)=>{var s=new XMLHttpRequest;s.open("GET",e,!0),s.overrideMimeType("text/plain; charset=x-user-defined"),s.responseType="arraybuffer",s.onprogress=e=>{t&&t(e.loaded/e.total)},s.onload=n=>{t&&t(1),200==s.status?i(s):r("Error downloading "+e+" ("+s.status+")")},s.onerror=t=>{r("Error downloading "+e+" (XHR)")},s.send()}))}document.addEventListener("mousedown",(function(t){null==e&&(e=new(window.AudioContext||window.webkitAudioContext))})),document.addEventListener("keydown",(function(t){null==e&&(e=new(window.AudioContext||window.webkitAudioContext))}));class o{constructor(e){this.lastCurrTime=0,this.lastTimeMs=0,this.timeSpeakerOn=0,this.audioGain=void 0,this.pc_speaker=void 0,this.volume=Math.min(1,Math.max(0,e&&e.volume||.2)),this.noteDelay=1}on(t,i,r){if(null==e)return;let s=e.currentTime;s!=this.lastCurrTime&&(this.lastCurrTime=s,this.lastTimeMs=t);let n=(t-this.lastTimeMs)/1e3;null==this.pc_speaker?(this.audioGain=e.createGain(),this.pc_speaker=e.createOscillator(),this.pc_speaker.type="square",this.pc_speaker.frequency.setValueAtTime(r,e.currentTime+n),this.pc_speaker.connect(this.audioGain),this.audioGain.connect(e.destination),this.audioGain.gain.setValueAtTime(this.volume,e.currentTime),this.pc_speaker.start(0)):this.pc_speaker.frequency.setValueAtTime(r,e.currentTime+n),this.timeSpeakerOn=t}off(t,i){if(null==this.pc_speaker)return;let r=e.currentTime;r!=this.lastCurrTime&&(this.lastCurrTime=r,this.lastTimeMs=t);let s=(t-this.lastTimeMs)/1e3;this.pc_speaker.frequency.setValueAtTime(0,e.currentTime+s)}setNoteDelay(e){this.noteDelay=e}setVolume(t){this.volume=Math.min(1,Math.max(0,t)),null!=this.pc_speaker&&this.audioGain.gain.setValueAtTime(this.volume,e.currentTime)}}class a{constructor(e,t){this.emu=e,this.sampleRate=t&&t.sampleRate||48e3,this.bufferSize=t&&t.bufferSize||2048,this.noteDelay=t&&t.noteDelay||void 0,this.volume=Math.min(1,Math.max(0,t&&t.volume||.2)),this.timeUnit=this.bufferSize/this.sampleRate,this.initialized=!1,this.lastTimeMs=0}_queueBufferSource(t){this.time+=this.timeUnit,this.time<e.currentTime&&(this.time=e.currentTime);const i=e.createBufferSource(),r=e.createBuffer(1,this.bufferSize,this.sampleRate);t&&t(r,i),i.buffer=r,i.onended=()=>this._queueNextSpeakerBuffer(),i.connect(e.destination),i.start(this.time)}_queueNextSpeakerBuffer(){const e=this;this._queueBufferSource(((t,i)=>{const s=e.bufferSize,n=e.nativeBuffer,o=e.nativeHeap,a=t.getChannelData(h);e.emu._audio_stream_generate(r(),n,2*e.bufferSize);for(let e=0;e<s;e++)a[e]=(o[e]-32768)/32768;for(var h=1;h<t.numberOfChannels;h++)t.getChannelData(h).set(a)}))}_initSpeaker(){return!!this.initialized||null!=e&&(this.initialized=!0,this.time=e.currentTime,this.emu._audio_generate_init(),this.emu._audio_stream_init(r(),this.sampleRate,!1,!0),this.emu._audio_stream_set_volume(Math.floor(this.volume*this.emu._audio_stream_get_max_volume())),this.noteDelay&&this.emu._audio_set_note_delay(this.noteDelay),this.nativeBuffer=this.emu._malloc(2*this.bufferSize),this.nativeHeap=new Uint16Array(this.emu.HEAPU8.buffer,this.nativeBuffer,this.bufferSize),this._queueBufferSource((()=>{})),this._queueNextSpeakerBuffer(),!0)}setNoteDelay(e){this.noteDelay=e,this.initialized&&this.emu._audio_set_note_delay(e)}setVolume(e){this.volume=Math.min(1,Math.max(0,e)),this.initialized&&this.emu._audio_stream_set_volume(Math.floor(this.volume*this.emu._audio_stream_get_max_volume()))}on(e,t,i){this._initSpeaker()&&this.emu._audio_stream_append_on(e,t,i)}off(e,t){this._initSpeaker()&&this.emu._audio_stream_append_off(e,t)}}class h{constructor(e,t){if(this.canvas=e,this.ctx=e.getContext("2d",{alpha:!1}),this.ctx.imageSmoothingEnabled=!1,this.offscreenCanvas=document.createElement("canvas"),this.offscreenCanvas.width=640,this.offscreenCanvas.height=400,this.offscreenCtx=this.offscreenCanvas.getContext("2d",{alpha:!1}),this.offscreenCtx.imageSmoothingEnabled=!1,this.blink_duration=Math.round(1e3*(t&&t.blink_cycle_duration||.534)),this.video_blink=this.blink_duration>0,this.video_mode=-1,this.chrBuf=[],this.drawChrWidth=void 0,this.chrWidth=void 0,this.scrWidth=void 0,this.chrHeight=void 0,this.scrHeight=void 0,this.pw=void 0,this.ph=void 0,this.cw=void 0,this.ch=void 0,this.scale=1,this.asciiFg=null,this.charset=null,this.palette=null,this.rdDirty=!1,this.charset_override_enabled=t&&t.charset_override||!1,this.charset_override=null,this.charset_override_enabled){let e=new Image,i=this;e.src=t.charset_override,e.onload=function(){i.charset_override=e,i.rdDirty=!0}}}_updVideoMode(e,t){e!=this.video_mode&&(this.chrBuf=[],this.scrWidth=2==(2&e)?80:40,this.scrHeight=25,this.video_mode=e),this.drawChrWidth=this.chrWidth*Math.round(80/this.scrWidth),this.pw=this.scrWidth*this.drawChrWidth,this.ph=this.scrHeight*this.chrHeight,this.cw=this.canvas.width,this.ch=this.canvas.height,this.scale=Math.floor(Math.min(this.cw/this.pw,this.ch/this.ph)),this.scale<1&&(this.scale=1),this.video_blink?t%this.blink_duration>=this.blink_duration/2?this.blink_state=2:this.blink_state=1:this.blink_state=0,this.x_offset=Math.round((this.cw-this.pw*this.scale)/2),this.y_offset=Math.round((this.ch-this.ph*this.scale)/2)}_drawChar(e,t,i,r,s){switch(this.blink_state){case 0:break;case 1:s&=127;break;case 2:s>=128&&(s=17*((112&s)>>4))}const n=r<<8|s;if(this.chrBuf[80*i+t]===n)return;this.chrBuf[80*i+t]=n,t*=this.chrWidth,i*=this.chrHeight;const o=s>>4&15,a=15&s;e.fillStyle=this.palette[o],e.fillRect(t,i,this.chrWidth,this.chrHeight),o!=a&&e.drawImage(this.asciiFg[a],(15&r)*this.chrWidth,(r>>4&15)*this.chrHeight,this.chrWidth,this.chrHeight,t,i,this.chrWidth,this.chrHeight)}_updRenderData(){if(null==this.palette)return;let e=null;if(this.charset_override_enabled){if(null==this.charset_override)return;e=this.charset_override}else if(null==this.charset)return;if(this.asciiFg=[],null==e){let a=document.createElement("canvas");a.width=16*this.chrWidth,a.height=16*this.chrHeight;let h=a.getContext("2d"),l=h.createImageData(a.width,a.height),u=l.data,c=0;for(var t=0;t<256;t++){let e=(15&t)*this.chrWidth,h=(t>>4)*this.chrHeight;for(var i=0;i<this.chrHeight;i++,c++)for(var r=(h+i)*a.width+e,s=this.charset[c],n=0;n<this.chrWidth;n++,r++,s<<=1){var o=255*(s>>7&1);u[4*r+0]=o,u[4*r+1]=o,u[4*r+2]=o,u[4*r+3]=o}}h.putImageData(l,0,0),e=a}for(var a=0;a<16;a++){if("#ffffff"==this.palette[a].toLowerCase()){this.asciiFg[a]=e;continue}let t=document.createElement("canvas");t.width=16*this.chrWidth,t.height=16*this.chrHeight;let i=t.getContext("2d");i.globalCompositeOperation="copy",i.drawImage(e,0,0),i.globalCompositeOperation="source-in",i.fillStyle=this.palette[a],i.fillRect(0,0,t.width,t.height),this.asciiFg[a]=t}this.chrBuf=[],this.rdDirty=!1}render(e,t,i){this.rdDirty&&this._updRenderData(),this._updVideoMode(t,i);let r=0,s=Math.floor(80/this.scrWidth);var n=this.canvas,o=this.ctx;if((this.scale>1||s>1||0!=this.x_offset||0!=this.y_offset)&&(n=this.offscreenCanvas,o=this.offscreenCtx),null!=this.asciiFg&&null!=this.palette)for(var a=0;a<25;a++)for(var h=0;h<this.scrWidth;h++,r+=2)this._drawChar(o,h,a,e[r],e[r+1]);o!=this.ctx&&(this.ctx.fillStyle="#000000",this.ctx.fillRect(0,0,this.canvas.width,this.canvas.height),this.ctx.drawImage(n,0,0,80*this.chrWidth/s,25*this.chrHeight,this.x_offset,this.y_offset,80*this.chrWidth*this.scale,25*this.chrHeight*this.scale))}setBlinkEnabled(e){this.blink_duration>0&&(this.video_blink=0!=e)}setBlinkCycleDuration(e){this.blink_duration=Math.round(1e3*e),this.video_blink=this.blink_duration>0}setCharset(e,t,i){this.chrWidth=e,this.chrHeight=t,this.charset=i.slice(0),this.rdDirty=!0}setPalette(e){this.palette=new Array;for(var t=0;t<16;t++){let i=(16777215&e[t]).toString(16);for(;i.length<6;)i="0"+i;this.palette[t]="#"+i}this.rdDirty=!0}}let l={ArrowUp:72,ArrowLeft:75,ArrowRight:77,ArrowDown:80,Home:71,End:79,Insert:82,Delete:83,PageUp:73,PageDown:81,Enter:28,Escape:1,Backspace:14,Tab:15,"-":12,_:12,"=":13,"+":13,"`":41,"~":41,"\\":43,"|":43,"*":55," ":57},u=function(e,t){for(var i=0;i<e.length;i++)l[e.charAt(i)]=t+i};u("1234567890",2),u("QWERTYUIOP{}",16),u("qwertyuiop[]",16),u("asdfghjkl;'",30),u('ASDFGHJKL:"',30),u("zxcvbnm,./",44),u("ZXCVBNM<>?",44);for(var c=1;c<=10;c++)l["F"+c]=58+c;const f=l,d={8:8,9:9,13:13,27:27};function _(e,t){if(null==t)return e;let i=[];for(var r=0;r<e.length;r++){const s=e[r];t(s)&&i.push(s)}return i}class m{constructor(e){this.use83Names=e&&e.use83Names||!1,this.ignoreCase=e&&e.ignoreCase||!1,this.readonly=e&&e.readonly||!1}_transformKey(e){var t=e;if("upper"==this.ignoreCase?t=t.toUpperCase():this.ignoreCase&&(t=t.toLowerCase()),this.use83Names){var i=t.split(".",2),r=!1;if(i[0].length>8&&(i[0]=i[0].substring(0,6),r=!0),i.length>=2&&i[1].length>3&&(i[1]=i[1].substring(0,3)),r)for(var s=1;;){var n=s.toString();if(i[0]=i[0].substring(0,7-n.length)+"~"+n,t=i.join("."),null==this.get(t))break;if((s+=1)>=1e3)throw new Error("Too many filenames! (at "+e+")")}else t=i.join(".")}return t}canSet(e){return!this.readonly&&(!this._canSet||this._canSet(this._transformKey(e)))}get(e){return this._get(this._transformKey(e))}list(e){return this._list(e)}set(e,t){return!this.readonly&&this._set(this._transformKey(e),t)}}class p{constructor(e){this.providers=e}canSet(e){for(var t=0;t<this.providers.length;t++){if(this.providers[t].canSet(e))return!0}return!1}get(e){for(var t=this.providers.length-1;t>=0;t--){const i=this.providers[t].get(e);if(null!=i)return i}return null}list(e){let t=[];for(var i=0;i<this.providers.length;i++){let r=this.providers[i];t=t.concat(r.list(e))}return t.sort().filter((function(e,t,i){return t<=0||e!=i[t-1]}))}set(e,t){Promise.resolve(!1);for(var i=this.providers.length-1;i>=0;i--){if(this.providers[i].set(e,t))return!0}return!1}}class g extends m{constructor(e,t){for(var i in super(t),this.map={},e)this.map[this._transformKey(i)]=e[i]}_get(e){return this.map.hasOwnProperty(e)?this.map[e].slice(0):null}_list(e){return _(Object.keys(this.map),e)}_set(e,t){return this.map[e]=t,!0}}class w extends g{constructor(e,t){super({},t),this.parent=e}_populate(){const e=this;return this.parent.list(null).then((t=>{e.map={};let i=[];for(var r=0;r<t.length;r++){const s=t[r];i.push(e.parent.get(s).then((e=>{this._set(s,e)})))}return Promise.all(i)}))}_set(e,t){return!!super._set(e,t)&&(this.parent.set(e,t),!0)}}class y extends m{constructor(e,t,i){super(i),this.storage=e,this.prefix=t+"_file_"}_get(e){const t=this.storage.getItem(this.prefix+e.toUpperCase());return t?t.split(",").map((e=>parseInt(e))):null}_list(e){for(var t=[],i=0;i<this.storage.length;i++){const e=this.storage.key(i);e.startsWith(this.prefix)&&t.push(e.substring(this.prefix.length))}return _(t,e)}_set(e,t){return this.storage.setItem(this.prefix+e,t.join(",")),!0}}class v{constructor(e,t){this.indexedDB=e,this.dbName=t}_open(){const e=this;return new Promise(((t,i)=>{var r=e.indexedDB.open(this.dbName,1);r.onupgradeneeded=t=>{e.database=t.target.result,e.files=e.database.createObjectStore("files",{keyPath:"filename"})},r.onsuccess=i=>{e.database=r.result,t()},r.onerror=e=>{i("Could not open IndexedDB! Upgrade your browser or disable private/incognito mode.")}}))}canSet(e){return Promise.resolve(!0)}get(e){const t=this.database.transaction(["files"],"readonly");return new Promise(((i,r)=>{const s=t.objectStore("files").get(e.toUpperCase());s.onsuccess=e=>{s.result&&s.result.value?i(s.result.value):i(null)},s.onerror=e=>{i(null)}}))}list(e){const t=this.database.transaction(["files"],"readonly");return new Promise(((i,r)=>{const s=t.objectStore("files");if("function"==typeof s.getAllKeys){const t=s.getAllKeys();t.onsuccess=r=>{i(_(t.result,e))},t.onerror=e=>{i([])}}else{var n,o=[];(n="function"==typeof s.openKeyCursor?s.openKeyCursor():s.openCursor()).onsuccess=t=>{var r=t.target.result;r?(o.push(r.key),r.continue()):i(_(o,e))},n.onerror=e=>{i(o)}}}))}set(e,t){const i=this.database.transaction(["files"],"readwrite");return new Promise(((r,s)=>{const n=i.objectStore("files").put({filename:e,value:t});n.onsuccess=e=>{r(!0)},n.onerror=e=>{r(!1)}}))}}function b(e,t){return new g(e,t)}function z(e,t,i){return n(e,i).then((i=>new Promise(((r,s)=>{let n,o={};try{n=UZIP.parse(i.response)}catch(e){return void s(e)}for(var a in n){const i=a;if(t&&t.filenameMapper)if("object"==typeof t.filenameMapper)a=t.filenameMapper[a]||void 0;else if("string"==typeof t.filenameMapper&&t.filenameMapper.length>0){let e=t.filenameMapper.toLowerCase();e.endsWith("/")||(e+="/"),a=a.toLowerCase().startsWith(e)?a.substring(e.length):void 0}else"function"==typeof t.filenameMapper&&(a=t.filenameMapper(a));a&&a.indexOf("/")>=0&&(console.warn("skipped file inside subdirectory: "+e+" -> "+a),a=void 0),a&&(t&&t.filenameFilter&&!t.filenameFilter(a)||(o[a]=n[i]))}r(b(o,t))}))))}let k,x=b({}),C={};function M(e){k=e}function S(e){x=e}function A(){window.vfsg_getcwd=function(e,t){if(t>0){new Uint8Array(k.HEAPU8.buffer,e,t)[0]=0}return 0},window.vfsg_chdir=function(e,t){return-1},window.vfsg_open=function(e,t){"string"!=typeof e&&(e=k.AsciiToString(e)),(e=e.toUpperCase()).length>=3&&58==e.charCodeAt(1)&&92==e.charCodeAt(2)&&(e=e.substring(3));let i=x.get(e);const r=1==(3&t);if(r){if(!x.canSet(e))return-1;null!=i&&0==(65536&t)||(i=new Uint8Array(0))}else if(null==i)return-1;let s=1;for(;s in C;)s++;return console.log("opening "+e+" at "+s),C[s]={fn:e,pos:0,mode:t,write_on_close:r,array:i},s},window.vfsg_close=function(e){return e in C?(C[e].write_on_close&&x.set(C[e].fn,C[e].array),delete C[e],0):-1},window.vfsg_seek=function(e,t,i){if(!(e in C))return-1;let r;switch(i){case 0:r=t;break;case 1:r=C[e].pos+t;break;case 2:r=C[e].array.length+t}return console.log("seek to "+r),r>C[e].array.length?r=C[e].array.length:r<0&&(r=0),C[e].pos=r,0},window.vfsg_read=function(e,t,i){if(!(e in C))return-1;e=C[e];let r=Math.min(i,e.array.length-e.pos);console.log("reading "+r+" bytes from "+e.pos+" to "+t);const s=new Uint8Array(k.HEAPU8.buffer,t,r);for(var n=0;n<r;n++)s[n]=e.array[e.pos+n];return console.log("read "+r+" bytes"),e.pos+=r,r},window.vfsg_write=function(e,t,i){if(!(e in C))return-1;let r=(e=C[e]).array.length,s=e.pos+i;if(s>r){var n=new Uint8Array(s);n.set(e.array,0),e.array=n,r=s}let o=new Uint8Array(k.HEAPU8.buffer,t,i);for(var a=0;a<i;a++)e.array[e.pos+a]=o[a];return console.log("wrote "+i+" bytes"),e.pos+=i,i},window.vfsg_truncate=function(e,t){if(!(e in C))return-1;if((e=C[e]).array.length>t){var i=new Uint8Array(t);i.set(e.array,0),e.array=i}else e.array.length<t&&(e.array=e.array.slice(0,t));return console.log("truncated"),0};var e=[],t=0;window.vfsg_findfirst=function(i,r,s){s=k.AsciiToString(s),e=[];const n=function(e){if((e=e.toUpperCase()).startsWith("*")){let t=e.substring(1),i=x.list((e=>0==t.length||e.endsWith(t)));return i.sort(((e,t)=>{const i=e.length-t.length;return 0!=i?i:e.localeCompare(t)})).map((e=>e.toUpperCase())),i}return console.log("unknown findfirst spec: "+e),null}(s);return null==n?-1:(e=n,t=0,vfsg_findnext(i))},window.vfsg_findnext=function(i){if(t>=e.length)return-1;const r=new Uint8Array(k.HEAPU8.buffer,i,256);r[21]=0,r[22]=0,r[23]=0,r[24]=0,r[25]=0;let s=e[t],n=x.get(s).byteLength;r[26]=255&n,r[27]=n>>8&255,r[28]=n>>16&255,r[29]=n>>24&255;for(var o=0;o<s.length;o++)r[30+o]=s.charCodeAt(o);return r[30+s.length]=0,t+=1,0}}const E=54.92457871,P=[0,1,2,3,4,5,20,7,56,57,58,59,60,61,62,63];class T{constructor(e,t,i,s,n,o){this.element=e,this.emu=t,this.render=i,this.audio=s,this.vfs=n,this.mouseSensitivity=o&&o.mouseSensitivity||4,this.frameQueued=!1,this.time_ms_cached=r(),this.time_ms_delay=void 0,this.last_timer_time=0,this.opcodes=1e3;const a=this;window.vfsg_time_ms=function(){return a.time_ms_cached},window.vfsg_has_feature=function(e){return 1==e||2==e},window.zetag_update_charset=function(e,r,s){const n=new Uint8Array(t.HEAPU8.buffer,s,256*r);i.setCharset(e,r,n)},window.zetag_update_palette=function(e){const r=new Uint32Array(t.HEAPU32.buffer,e,16);i.setPalette(r)},window.zetag_update_blink=function(e){i.setBlinkEnabled(e)},window.speakerg_on=function(e,t){document.hasFocus()?null!=s&&s.on(a.time_ms_cached,e,t):speakerg_off()},window.speakerg_off=function(e){null!=s&&s.off(a.time_ms_cached,e)},window.addEventListener("message",(function(e){"zzt_tick"==e.data&&(e.stopPropagation(),a._tick())}),!0);var h=function(e){!0===e.shiftKey?t._zzt_kmod_set(1):!1===e.shiftKey&&t._zzt_kmod_clear(1),!0===e.ctrlKey?t._zzt_kmod_set(4):!1===e.ctrlKey&&t._zzt_kmod_clear(4),!0===e.altKey?t._zzt_kmod_set(8):!1===e.altKey&&t._zzt_kmod_clear(8)};document.addEventListener("keydown",(function(i){if(i.target!=e)return!1;let r=!1;h(i),"Shift"==i.key?t._zzt_kmod_set(1):"Control"==i.key?t._zzt_kmod_set(4):"Alt"==i.key||"AltGraph"==i.key?t._zzt_kmod_set(8):r=!1;let s=1==i.key.length?i.key.charCodeAt(0):d[i.keyCode]||0,n=f[i.key]||0;return n>=70&&n<=83&&(s=0),(s>0||n>0)&&(t._zzt_key(s,n),r=!0),r&&i.preventDefault(),!1}),!1),document.addEventListener("keyup",(function(i){if(i.target!=e)return!1;let r=!0;h(i),"Shift"==i.key?t._zzt_kmod_clear(1):"Control"==i.key?t._zzt_kmod_clear(4):"Alt"==i.key||"AltGraph"==i.key?t._zzt_kmod_clear(8):r=!1;var s=f[i.key]||0;return s>0&&(t._zzt_keyup(s),r=!0),r&&i.preventDefault(),!1}),!1),this.element.addEventListener("mousemove",(function(e){if(null==t)return;const i=e.movementX*a.mouseSensitivity,r=e.movementY*a.mouseSensitivity;t._zzt_mouse_axis(0,i),t._zzt_mouse_axis(1,r)})),this.element.addEventListener("mousedown",(function(i){e.requestPointerLock(),null!=t&&(0==i.button?t._zzt_mouse_set(0):2==i.button?t._zzt_mouse_set(1):1==i.button&&t._zzt_mouse_set(2))})),this.element.addEventListener("mouseup",(function(e){null!=t&&(0==e.button?t._zzt_mouse_clear(0):2==e.button?t._zzt_mouse_clear(1):1==e.button&&t._zzt_mouse_clear(2))}))}loadCharset(e){const t=this.emu;if("string"==typeof e&&(e=this.vfs.get(e)),"object"==typeof e){if(0!=(255&e.length))return!1;const i=8,r=e.length>>8;if(r<=0||r>16)return!1;let s=!1;return this._u8array2buffer(e,(e=>{s=t._zzt_load_charset(i,r,e,!1)>=0})),s}return!1}_pal_file_append(e,t,i,r){const s=Math.floor(255*t[i]/r),n=Math.floor(255*t[i+1]/r),o=Math.floor(255*t[i+2]/r);e.push(o,n,s,0)}loadPalette(e){const t=this.emu;let i=[];if("string"==typeof e){let t="pal";e.toLowerCase().endsWith(".pld")&&(t="pld");const s=this.vfs.get(e);if(null==s)return!1;if("pld"==t){if(s.length<192)return!1;for(var r=0;r<16;r++)this._pal_file_append(i,s,3*P[r],63)}else{if(s.length<48)return!1;for(r=0;r<16;r++)this._pal_file_append(i,s,3*r,63)}}else if("object"==typeof e){const t=e.min||0,s=e.max||255;if(null==e.colors||e.colors.length<16)return console.warn("[zeta.loadPalette] missing or too small colors array"),!1;for(r=0;r<16;r++){const n=e.colors[r];if("string"==typeof n&&n.startsWith("#"))if(7==n.length){const e=parseInt(n.substring(1,3),16),t=parseInt(n.substring(3,5),16),r=parseInt(n.substring(5,7),16);i.push(r,t,e,0)}else{if(4!=n.length)return console.warn("[zeta.loadPalette] invalid color string length: "+n.length),!1;{const e=17*parseInt(n.substring(1,2),16),t=17*parseInt(n.substring(2,3),16),r=17*parseInt(n.substring(3,4),16);i.push(r,t,e,0)}}else{if(!("object"==typeof n&&n.length>=3))return console.warn("[zeta.loadPalette] invalid color type @ "+r),!1;{const n=Math.floor(255*(e.colors[r][0]-t)/(s-t)),o=Math.floor(255*(e.colors[r][1]-t)/(s-t)),a=Math.floor(255*(e.colors[r][2]-t)/(s-t));i.push(a,o,n,0)}}}}if(64==i.length){let e=!1;return this._u8array2buffer(i,(i=>{e=t._zzt_load_palette(i)>=0})),e}return!1}setBlinkCycleDuration(e){return this.render.setBlinkCycleDuration(e),!0}setVolume(e){return this.audio.setVolume(e),!0}getFile(e){return this.vfs.get(e)}listFiles(){return this.vfs.list()}_frame(){this._pollGamepads();const e=this.emu._zzt_get_ram(),t=new Uint8Array(this.emu.HEAPU8.buffer,e+753664,4e3);this.render.render(t,this.emu._zzt_video_mode(),this.time_ms_cached),this.emu._zzt_mark_frame(),this.frameQueued=!1}_resetLastTimerTime(){this.last_timer_time=r()}_tick(){for(this.time_ms_cached=r();this.time_ms_cached-this.last_timer_time>=E;)this.last_timer_time+=E,this.emu._zzt_mark_timer();const e=this.emu._zzt_execute(this.opcodes),t=r()-this.time_ms_cached;if(0!=e){t<5&&1==e?this.opcodes=20*this.opcodes/19:t>10&&(this.opcodes=19*this.opcodes/20),this.frameQueued||(this.frameQueued=!0,window.requestAnimationFrame((()=>this._frame())));const i=E-(this.time_ms_cached+t-this.last_timer_time);e<3||i<=1?window.postMessage("zzt_tick","*"):e>=5?setTimeout((()=>this._tick()),Math.min(e-5,i)):4==e||i<20?setTimeout((()=>this._tick()),i):window.requestAnimationFrame((()=>this._tick()))}else i(this.render.canvas,this.render.ctx,"Emulation stopped.")}_pollGamepads(){if(!navigator.getGamepads||"function"!=typeof navigator.getGamepads)return;const e=navigator.getGamepads();for(var t=0;t<e.length;t++){const r=e[t];if(null!=r&&r.axes.length>=2&&r.buttons.length>=1){const e=Math.round(127*r.axes[0]),t=Math.round(127*r.axes[1]);this.emu._zzt_joy_axis(0,e),this.emu._zzt_joy_axis(1,t);let s=!1;for(var i=0;i<r.buttons.length;i++)if(r.buttons[i].pressed){s=!0;break}s?this.emu._zzt_joy_set(0):this.emu._zzt_joy_clear(0)}}}_u8array2buffer(e,t){const i=this.emu._malloc(e.length),r=new Uint8Array(this.emu.HEAPU8.buffer,i,e.length);for(var s=0;s<e.length;s++)r[s]=e[s];t(i),this.emu._free(i)}_str2buffer(e,t){const i=this.emu._malloc(e.length+1),r=new Uint8Array(this.emu.HEAPU8.buffer,i,e.length+1);for(var s=0;s<e.length;s++){var n=e.charCodeAt(s);r[s]=n>=127?0:n}r[e.length]=0,t(i),this.emu._free(i)}}const D="beta39";class U{constructor(e,t,i,r){this.canvas=e,this.ctx=t,this.loaded=!1,this.path=r.path}_drawBackground(){const e=this;return new Promise(((t,i)=>{const r=new Image;r.onload=function(){const i=D,s=r.width,n=r.height;e.ctx.drawImage(r,0,0,s,n,(e.canvas.width-2*s)/2,(e.canvas.height-2*n)/2,2*s,2*n),e.ctx.font="16px sans-serif",e.ctx.fillStyle="#aaaaaa",e.ctx.textBaseline="bottom",e.ctx.fillText(i,(e.canvas.width+2*s)/2-6-e.ctx.measureText(i).width,(e.canvas.height+2*n)/2-6),e.loaded=!0,t(!0)},r.src=e.path+"loading.png"}))}progress(e){if(!this.loaded)return;const t=this.canvas,i=this.ctx,r=(t.width-640)/2,s=(t.height-350)/2;i.fillStyle="#ff0000",i.fillRect(r+28,s+224,292*e*2,20)}}window.ZetaInitialize=function(e,t){if(console.log("         _        \n _______| |_ __ _ \n|_  / _ \\ __/ _` |\n / /  __/ || (_| |\n/___\\___|\\__\\__,_|\n\n "+D),!e.render)throw new Error("Missing option: render!");if(!e.render.canvas)throw new Error("Missing option: render.canvas!");const r=e.render.canvas;r.contentEditable=!0;const l=r.getContext("2d",{alpha:!1});l.imageSmoothingEnabled=!1;try{if(!e.path)throw new Error("Missing option: path!");if(!e.files)throw new Error("Missing option: files!")}catch(e){return i(r,l,e),Promise.reject(e)}const u=new U(r,l,D,e);var c=[],f=[],d=[];try{for(var _ in e.files)f.push(0),function(t,i){const r=function(i){f[t]=Math.min(i,1),u.progress(f.reduce(((e,t)=>e+t))/e.files.length)};var s=i;if(!s.hasOwnProperty("type"))throw new Error("Missing option: files.type!");if(s.hasOwnProperty("readonly")||(s.readonly=!0),s.hasOwnProperty("ignoreCase")||(s.ignoreCase="upper"),s.use83Names=!0,"zip"==s.type){if(!s.hasOwnProperty("url"))throw new Error("Missing option: files.url!");c.push(z(s.url,s,r).then((e=>d.push(e))))}else if("array"==s.type){if(!s.hasOwnProperty("filename"))throw new Error("Missing option: files.filename!");if(!s.hasOwnProperty("data"))throw new Error("Missing option: files.data!");var o={};o[s.filename]=new Uint8Array(s.data),d.push(b(o,s))}else if("file"==s.type){if(!s.hasOwnProperty("url"))throw new Error("Missing option: files.url!");if(!s.hasOwnProperty("filename"))throw new Error("Missing option: files.filename!");c.push(n(s.url,r).then((e=>{var t={};t[s.filename]=new Uint8Array(e.response),d.push(b(t,s))})))}}(f.length-1,e.files[_])}catch(e){return i(r,l,e),Promise.reject(e)}u._drawBackground().then((e=>Promise.all(c))).then((t=>{var i=!1;if(e.storage&&"auto"==e.storage.type&&(i=!0,null!=s()?e.storage.type="indexeddb":null!=function(){try{return window.localStorage}catch(e){return}}()?e.storage.type="localstorage":(console.log("Browser does not support any form of local storage! Storing to memory..."),e.storage=void 0)),e.storage&&e.storage.type){var r=null;if("indexeddb"==e.storage.type){if(!e.storage.database)throw new Error("Missing option: storage.database!");r=function(e){const t=s();if(!t)return Promise.reject("IndexedDB not supported!");const i=new v(t,e);return i._open().then((e=>i))}("zeta_"+e.storage.database).then((e=>function(e,t){const i=new w(e,t);return i._populate().then((e=>i))}(e,{ignoreCase:"upper"}))).then((e=>d.push(e)))}else{if("localstorage"!=e.storage.type)throw new Error("Unknown storage type: "+e.storage.type);r=new Promise((t=>{if(!e.storage.database)throw new Error("Missing option: storage.database!");let i=window.localStorage;if(e.storage.storage&&(i=e.storage.storage),null==i)throw new Error("Could not find storage object!");return d.push(function(e,t,i){return new y(e,t,i)}(i,"zeta_"+e.storage.database,{ignoreCase:"upper"})),!0}))}return i&&(r=r.catch((t=>(console.log("Browser failed to initialize local storage (type "+e.storage.type+", reason: "+t+"). Storing to memory..."),d.push(b({},{readonly:!1,ignoreCase:"upper"})),!0)))),r}return d.push(b({},{readonly:!1,ignoreCase:"upper"})),!0})).then((i=>{let s,n;l.fillStyle="#000000",l.fillRect(0,0,r.width,r.height),e&&e.render&&e.render.type,s=t=>new h(e.render.canvas,e.render),n="oscillator"==(e&&e.audio&&e.audio.type||"auto")?t=>new o(e.audio):t=>new a(t,e.audio);const u=function(e,t){return new p(e,t)}(d);return function(e,t,i,r){return new Promise((s=>{ZetaNative().then((n=>{S(i),M(n),A();const o=new T(r.render.canvas,n,e(n),t(n),i,r);if(n._zzt_init(r&&r.engine&&r.engine.memory_limit||-1),n._zzt_set_max_extended_memory(r&&r.engine&&r.engine.extended_memory_limit||-1),n._zzt_set_timer_offset(Date.now()%864e5),r&&r.commands){const e=r.commands.length-1;for(var a=0;a<=e;a++){let t=r.commands[a];"string"==typeof t&&(t=[t,""]);let i=vfsg_open(t[0].toLowerCase(),0);if(i<0)throw new Error("Could not find executable "+t[0]+" (command #"+(a+1)+")!");if(o._str2buffer(t[1],(e=>{n._zzt_load_binary(i,e)})),vfsg_close(i),console.log("executing "+t[0]+" "+t[1]),a<e)for(;0!=n._zzt_execute(1e4););}}else{let e="zzt.exe",t=vfsg_open(e,0),s=".zzt";if(t<0&&(e="superz.exe",t=vfsg_open(e,0),s=void 0),t<0)throw new Error("Could not find ZZT/Super ZZT executable!");let a="";if(r&&r.arg)a=r.arg;else if(null!=s){const e=i.list((e=>e.toLowerCase().endsWith(s)));e.length>0&&(a=e[0])}o._str2buffer(a,(e=>{n._zzt_load_binary(t,e)})),vfsg_close(t),console.log("executing "+e+" "+a)}r&&r.engine&&(r.engine.charset&&(o.loadCharset(r.engine.charset)||console.error("Could not load charset from options!")),r.engine.palette&&(o.loadPalette(r.engine.palette)||console.error("Could not load palette from options!"))),o._resetLastTimerTime(),o._tick(),s(o)}))}))}(s,n,u,e).then((e=>(null!=t&&t(e),e)))})).then((e=>!0)).catch((e=>{t(void 0,e),i(r,l,e)}))}}();
